VERSION 5.00
Object = "{12520523-29BC-11D0-A2B7-CFA54B507249}#1.0#0"; "ACTIVECDX.OCX"
Begin VB.Form Form1 
   Caption         =   "ActiveCDX Example2 - Introduction to CDXDraw"
   ClientHeight    =   3879
   ClientLeft      =   36
   ClientTop       =   243
   ClientWidth     =   5274
   LinkTopic       =   "Form1"
   ScaleHeight     =   3879
   ScaleWidth      =   5274
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Exit 
      Caption         =   "Exit"
      Height          =   360
      Left            =   0
      TabIndex        =   4
      Top             =   1404
      Width           =   594
   End
   Begin VB.CommandButton Button 
      Caption         =   "Circle"
      Height          =   360
      Index           =   3
      Left            =   0
      TabIndex        =   3
      Top             =   1053
      Width           =   594
   End
   Begin VB.Timer Timer1 
      Interval        =   10
      Left            =   819
      Top             =   1521
   End
   Begin VB.CommandButton Button 
      Caption         =   "Rect"
      Height          =   360
      Index           =   2
      Left            =   0
      TabIndex        =   2
      Top             =   702
      Width           =   594
   End
   Begin VB.CommandButton Button 
      Caption         =   "Line"
      Height          =   360
      Index           =   1
      Left            =   0
      TabIndex        =   1
      Top             =   351
      Width           =   594
   End
   Begin VB.CommandButton Button 
      Caption         =   "Stop"
      Height          =   360
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   594
   End
   Begin ACTIVECDXLib.CDXDraw CDXDraw 
      Left            =   3159
      Top             =   468
      _Version        =   65536
      _ExtentX        =   635
      _ExtentY        =   635
      _StockProps     =   0
   End
   Begin ACTIVECDXLib.CDXVisual CDXVisual 
      Left            =   2340
      Top             =   351
      _Version        =   65536
      _ExtentX        =   841
      _ExtentY        =   841
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Demo As Integer

Private Sub CDX_Error(msg As String)
    Rem There is an error, destroy cdx and quit
    CDXVisual.Destroy
    MsgBox msg
    Unload Me
End Sub

Private Sub Button_Click(Index As Integer)
    Demo = Index
    Call CDXVisual.Fill(CDXVisual.GetBack, 0)
End Sub

Private Sub Exit_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Randomize
    Rem Create the windowed CDX
    If Not CDXVisual.CreateWindowed(Form1.hWnd, 640, 480) Then
        CDX_Error ("Failed creating windowed CDX")
    End If
    Demo = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    CDXVisual.Destroy
End Sub

Private Sub Timer1_Timer()
    Rem Exit if no button selected
    If Demo = 0 Then Exit Sub
    
    Dim BackBuffer As Long
    Dim x1, y1, x2, y2, radius, color As Long
    
    Rem Get and lock the backbuffer
    BackBuffer = CDXVisual.GetBack
    CDXVisual.Lock (BackBuffer)

    Rem Generate random position and color
    x1 = Int(640 * Rnd)
    y1 = Int(480 * Rnd)
    x2 = Int(640 * Rnd)
    y2 = Int(480 * Rnd)
    radius = Int(50 * Rnd)
    color = Int((60000 * Rnd) + 1)
    
    Rem Draw something
    Select Case Demo
        Case 1
            Call CDXDraw.Line2(BackBuffer, x1, y1, x2, y2, color)
        Case 2
            Call CDXDraw.Rect(BackBuffer, x1, y1, x2, y2, color)
        Case 3
            Call CDXDraw.FillCircle(BackBuffer, x1, y1, radius, color)
    End Select
    
    Rem Unlock and flip
    CDXVisual.Unlock (BackBuffer)
    CDXVisual.Flip
End Sub
