// Ex2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ex2.h"
#include "Ex2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx2Dlg dialog

CEx2Dlg::CEx2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEx2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEx2Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEx2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEx2Dlg)
	DDX_Control(pDX, IDC_CDXDRAWCTRL, m_Draw);
	DDX_Control(pDX, IDC_CDXVISUALCTRL, m_Visual);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEx2Dlg, CDialog)
	//{{AFX_MSG_MAP(CEx2Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_LINE, OnLine)
	ON_BN_CLICKED(IDC_RECT, OnRect)
	ON_BN_CLICKED(IDC_CIRCLE, OnCircle)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx2Dlg message handlers

BOOL CEx2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetTimer(1, 10, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEx2Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEx2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEx2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEx2Dlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	m_Demo = 0;
	m_Visual.Fill(m_Visual.GetBack(), 0);
}

void CEx2Dlg::OnLine() 
{
	// TODO: Add your control notification handler code here
	m_Demo = 1;
	m_Visual.Fill(m_Visual.GetBack(), 0);
}

void CEx2Dlg::OnRect() 
{
	// TODO: Add your control notification handler code here
	m_Demo = 2;
	m_Visual.Fill(m_Visual.GetBack(), 0);
}

void CEx2Dlg::OnCircle() 
{
	// TODO: Add your control notification handler code here
	m_Demo = 3;
	m_Visual.Fill(m_Visual.GetBack(), 0);
}

void CEx2Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	static BOOL firstTime = TRUE;
    if (firstTime)
    {
        firstTime = FALSE;
		srand( (unsigned)time( NULL ) );
        if (!m_Visual.CreateWindowed((long)GetSafeHwnd(), 640, 480))
        {
            MessageBox("Failed creating windowed CDX");
            PostQuitMessage(0);
            return;
        }
	}
	
	// Don't bother if no shape to draw
	if (m_Demo != 0)
	{
        // Get and lock the backbuffer
		long backBuffer = m_Visual.GetBack();
        m_Visual.Lock(backBuffer);
		
        // Generate random position and color
		long x1 = (rand()*640)/RAND_MAX;
		long y1 = (rand()*480)/RAND_MAX;
		long x2 = (rand()*640)/RAND_MAX;
		long y2 = (rand()*480)/RAND_MAX;
		long radius = (rand()*50)/RAND_MAX;
		long color = rand()*rand();

        // Draw the shape
        switch (m_Demo)
		{
			case 1:
				m_Draw.Line(backBuffer, x1, y1, x2, y2, color);
				break;
            case 2:
                m_Draw.Rect(backBuffer, x1, y1, x2, y2, color);
				break;
            case 3:
                m_Draw.FillCircle(backBuffer, x1, y1, radius, color);
				break;
		}

        // Unlock and flip
        m_Visual.Unlock(backBuffer);
        m_Visual.Flip();

		Invalidate(FALSE);
    }

	CDialog::OnTimer(nIDEvent);
}
