VERSION 5.00
Object = "{12520523-29BC-11D0-A2B7-CFA54B507249}#1.0#0"; "ACTIVECDX.OCX"
Begin VB.Form Form1 
   Caption         =   "ActiveCDX Example1 - Introduction to CDXVisual"
   ClientHeight    =   3411
   ClientLeft      =   36
   ClientTop       =   243
   ClientWidth     =   4707
   LinkTopic       =   "Form1"
   ScaleHeight     =   3411
   ScaleWidth      =   4707
   StartUpPosition =   3  'Windows Default
   Begin ACTIVECDXLib.CDXVisual CDXVisual 
      Left            =   585
      Top             =   351
      _Version        =   65536
      _ExtentX        =   1048
      _ExtentY        =   1254
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Splash As Long

Private Sub CDX_Error(msg As String)
    Rem There is an error, destroy cdx and quit
    CDXVisual.Destroy
    MsgBox msg
    Unload Me
End Sub

Private Sub Paint_Splash()
    Rem Blit the Splash to the back buffer and then flip
    Dim HResult As Long
    HResult = CDXVisual.DrawFast(CDXVisual.GetBack, 0, 0, Splash)
    CDXVisual.Flip
End Sub

Private Sub Form_Load()
    Rem Create the windowed CDX
    If Not CDXVisual.CreateWindowed(Form1.hWnd, 640, 480) Then
        CDX_Error ("Failed creating windowed CDX")
    End If
    Rem Load the splash
    Splash = CDXVisual.CreateSurface4("c:\cdx\acdx\examples\res\splash.bmp", 2)
    If Splash = 0 Then
        CDX_Error ("Failed loading c:\cdx\acdx\examples\res\splash.bmp")
    End If
End Sub

Private Sub Form_Paint()
    Paint_Splash
End Sub

Private Sub Form_Resize()
    Paint_Splash
End Sub

Private Sub Form_Unload(Cancel As Integer)
    CDXVisual.Destroy
End Sub
